Index: common/strtol.c
===================================================================
--- common/strtol.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ common/strtol.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,562 @@
+/*
+ * Copyright (c) 2005 Martin Decky
+ * Copyright (c) 2008 Jiri Svoboda
+ * Copyright (c) 2011 Martin Sucha
+ * Copyright (c) 2011 Oleg Romanenko
+ * Copyright (c) 2011 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <assert.h>
+#include <ctype.h>
+#include <errno.h>
+#include <inttypes.h>
+#include <limits.h>
+#include <stdbool.h>
+#include <stdlib.h>
+#include <str.h>
+
+// FIXME: The original HelenOS functions return EOVERFLOW instead
+//        of ERANGE. It's a pointless distinction from standard functions,
+//        so we should change that. Beware the callers though.
+
+// TODO: more unit tests
+
+static inline int _digit_value(int c)
+{
+	if (isdigit(c)) {
+		return c - '0';
+	} else if (islower(c)) {
+		return c - 'a' + 10;
+	} else if (isupper(c)) {
+		return c - 'A' + 10;
+	}
+	return INT_MAX;
+}
+
+/*
+ * FIXME: workaround for GCC "optimizing" the overflow check
+ * into soft-emulated 128b multiplication using `__multi3`,
+ * which we don't currently implement.
+ */
+__attribute__((noinline)) static uintmax_t _max_value(int base)
+{
+	return UINTMAX_MAX / base;
+}
+
+static inline int _prefixbase(const char *restrict *nptrptr, bool nonstd)
+{
+	const char *nptr = *nptrptr;
+
+	if (nptr[0] != '0')
+		return 10;
+
+	if (nptr[1] == 'x' || nptr[1] == 'X') {
+		if (_digit_value(nptr[2]) < 16) {
+			*nptrptr += 2;
+			return 16;
+		}
+	}
+
+	if (nonstd) {
+		switch (nptr[1]) {
+		case 'b':
+		case 'B':
+			if (_digit_value(nptr[2]) < 2) {
+				*nptrptr += 2;
+				return 2;
+			}
+			break;
+		case 'o':
+		case 'O':
+			if (_digit_value(nptr[2]) < 8) {
+				*nptrptr += 2;
+				return 8;
+			}
+			break;
+		case 'd':
+		case 'D':
+		case 't':
+		case 'T':
+			if (_digit_value(nptr[2]) < 10) {
+				*nptrptr += 2;
+				return 10;
+			}
+			break;
+		}
+	}
+
+	return 8;
+}
+
+static inline uintmax_t _strtoumax(
+    const char *restrict nptr, char **restrict endptr, int base,
+    bool *restrict sgn, errno_t *err, bool nonstd)
+{
+	assert(nptr != NULL);
+	assert(sgn != NULL);
+
+	const char *first = nptr;
+
+	/* Skip leading whitespace. */
+
+	while (isspace(*nptr)) {
+		nptr++;
+	}
+
+	/* Parse sign, if any. */
+
+	switch (*nptr) {
+	case '-':
+		*sgn = true;
+		nptr++;
+		break;
+	case '+':
+		nptr++;
+		break;
+	}
+
+	/* Figure out the base. */
+
+	if (base == 0)
+		base = _prefixbase(&nptr, nonstd);
+
+	if (base == 16 && !nonstd) {
+		/*
+		 * Standard strto* functions allow hexadecimal prefix to be
+		 * present when base is explicitly set to 16.
+		 * Our nonstandard str_* functions don't allow it.
+		 * I don't know if that is intended, just matching the original
+		 * functionality here.
+		 */
+
+		if (nptr[0] == '0' && (nptr[1] == 'x' || nptr[1] == 'X') &&
+		    _digit_value(nptr[2]) < base)
+			nptr += 2;
+	}
+
+	if (base < 2 || base > 36) {
+		*err = EINVAL;
+		return 0;
+	}
+
+	/* Must be at least one digit. */
+
+	if (_digit_value(*nptr) >= base) {
+		/* No digits on input. */
+		if (endptr != NULL)
+			*endptr = (char *) first;
+		return 0;
+	}
+
+	/* Read the value.  */
+
+	uintmax_t result = 0;
+	uintmax_t max = _max_value(base);
+	int digit;
+
+	while (digit = _digit_value(*nptr), digit < base) {
+		if (result > max ||
+		    __builtin_add_overflow(result * base, digit, &result)) {
+
+			*err = nonstd ? EOVERFLOW : ERANGE;
+			result = UINTMAX_MAX;
+			break;
+		}
+
+		nptr++;
+	}
+
+	/* Set endptr. */
+
+	if (endptr != NULL) {
+		/*
+		 * Move the pointer to the end of the number,
+		 * in case it isn't there already.
+		 * This can happen when the number has legal formatting,
+		 * but is out of range of the target type.
+		 */
+		while (_digit_value(*nptr) < base) {
+			nptr++;
+		}
+
+		*endptr = (char *) nptr;
+	}
+
+	return result;
+}
+
+static inline intmax_t _strtosigned(const char *nptr, char **endptr, int base,
+    intmax_t min, intmax_t max, errno_t *err, bool nonstd)
+{
+	bool sgn = false;
+	uintmax_t number = _strtoumax(nptr, endptr, base, &sgn, err, nonstd);
+
+	if (number > (uintmax_t) max) {
+		if (sgn && (number - 1 == (uintmax_t) max)) {
+			return min;
+		}
+
+		*err = nonstd ? EOVERFLOW : ERANGE;
+		return (sgn ? min : max);
+	}
+
+	return (sgn ? -number : number);
+}
+
+static inline uintmax_t _strtounsigned(const char *nptr, char **endptr, int base,
+    uintmax_t max, errno_t *err, bool nonstd)
+{
+	bool sgn = false;
+	uintmax_t number = _strtoumax(nptr, endptr, base, &sgn, err, nonstd);
+
+	if (nonstd && sgn) {
+		/* Do not allow negative values */
+		*err = EINVAL;
+		return 0;
+	}
+
+	if (number > max) {
+		*err = nonstd ? EOVERFLOW : ERANGE;
+		return max;
+	}
+
+	return (sgn ? -number : number);
+}
+
+/** Convert initial part of string to long int according to given base.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param[out] endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character.
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
+ */
+long strtol(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtosigned(nptr, endptr, base, LONG_MIN, LONG_MAX, &errno, false);
+}
+
+/** Convert initial part of string to unsigned long according to given base.
+ * The number may begin with an arbitrary number of whitespaces followed by
+ * optional sign (`+' or `-'). If the base is 0 or 16, the prefix `0x' may be
+ * inserted and the number will be taken as hexadecimal one. If the base is 0
+ * and the number begin with a zero, number will be taken as octal one (as with
+ * base 8). Otherwise the base 0 is taken as decimal.
+ *
+ * @param nptr		Pointer to string.
+ * @param[out] endptr	If not NULL, function stores here pointer to the first
+ * 			invalid character
+ * @param base		Zero or number between 2 and 36 inclusive.
+ * @return		Result of conversion.
+ */
+unsigned long strtoul(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtounsigned(nptr, endptr, base, ULONG_MAX, &errno, false);
+}
+
+long long strtoll(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtosigned(nptr, endptr, base, LLONG_MIN, LLONG_MAX, &errno, false);
+}
+
+unsigned long long strtoull(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtounsigned(nptr, endptr, base, ULLONG_MAX, &errno, false);
+}
+
+intmax_t strtoimax(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtosigned(nptr, endptr, base, INTMAX_MIN, INTMAX_MAX, &errno, false);
+}
+
+uintmax_t strtoumax(const char *nptr, char **endptr, int base)
+{
+#if !__STDC_HOSTED__
+	errno_t errno;
+#endif
+
+	return _strtounsigned(nptr, endptr, base, UINTMAX_MAX, &errno, false);
+}
+
+int atoi(const char *nptr)
+{
+	return (int)strtol(nptr, NULL, 10);
+}
+
+long atol(const char *nptr)
+{
+	return strtol(nptr, NULL, 10);
+}
+
+long long atoll(const char *nptr)
+{
+	return strtoll(nptr, NULL, 10);
+}
+
+/** Convert string to uint8_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_uint8_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, uint8_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	uintmax_t r = _strtounsigned(nptr, &lendptr, base, UINT8_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** Convert string to uint16_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_uint16_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, uint16_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	uintmax_t r = _strtounsigned(nptr, &lendptr, base, UINT16_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** Convert string to uint32_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_uint32_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, uint32_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	uintmax_t r = _strtounsigned(nptr, &lendptr, base, UINT32_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** Convert string to uint64_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_uint64_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, uint64_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	uintmax_t r = _strtounsigned(nptr, &lendptr, base, UINT64_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** Convert string to int64_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_int64_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, int64_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	intmax_t r = _strtosigned(nptr, &lendptr, base, INT64_MIN, INT64_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** Convert string to size_t.
+ *
+ * @param nptr   Pointer to string.
+ * @param endptr If not NULL, pointer to the first invalid character
+ *               is stored here.
+ * @param base   Zero or number between 2 and 36 inclusive.
+ * @param strict Do not allow any trailing characters.
+ * @param result Result of the conversion.
+ *
+ * @return EOK if conversion was successful.
+ *
+ */
+errno_t str_size_t(const char *nptr, const char **endptr, unsigned int base,
+    bool strict, size_t *result)
+{
+	assert(result != NULL);
+
+	errno_t rc = EOK;
+	char *lendptr = (char *) nptr;
+
+	uintmax_t r = _strtounsigned(nptr, &lendptr, base, SIZE_MAX, &rc, true);
+
+	if (endptr)
+		*endptr = lendptr;
+
+	if (rc != EOK)
+		return rc;
+
+	if (strict && *lendptr != '\0')
+		return EINVAL;
+
+	*result = r;
+	return EOK;
+}
+
+/** @}
+ */
Index: configure.sh
===================================================================
--- configure.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ configure.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -164,5 +164,5 @@
 sed "s:@COMPPREFIX@:$compprefix:g" "$cross_def" > crossfile || exit 1
 
-meson "${SOURCE_DIR}" '.' --cross-file crossfile || exit 1
+meson setup "${SOURCE_DIR}" '.' --cross-file crossfile || exit 1
 
 echo
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ contrib/qemu/build-from-scratch.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -29,5 +29,5 @@
 #
 
-VERSION=6.0.0
+VERSION=8.0.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
@@ -35,5 +35,5 @@
 SOURCEDIR=${BASENAME}
 URL=https://download.qemu.org/${TARBALL}
-REPO=git://git.qemu.org/qemu.git
+REPO=git@github.com:qemu/qemu.git
 
 OPENSPARC_TARBALL="OpenSPARCT1_Arch.1.5.tar.bz2"
@@ -42,4 +42,5 @@
 ARCHIVE_PREFIX="./S10image"
 BINARIES="1up-hv.bin 1up-md.bin nvram1 openboot.bin q.bin reset.bin"
+INSTALL_PREFIX="$HOME/.local"
 
 echo "==== Downloading OpenSPARC archive ===="
@@ -77,6 +78,6 @@
 echo "==== Installing OpenSPARC binaries ===="
 
-sudo install -d /usr/local/opensparc/image
-sudo install -m 0444 binaries/* /usr/local/opensparc/image
+install -d "$INSTALL_PREFIX/opensparc/image"
+install -m 0444 binaries/* "$INSTALL_PREFIX/opensparc/image"
 
 echo "==== Obtaining QEMU sources ===="
@@ -94,5 +95,5 @@
 	fi
 
-	gpg --verify ${TARBALL}.sig ${TARBALL}
+	gpg --auto-key-retrieve --verify ${TARBALL}.sig ${TARBALL}
 	if [ $? -ne 0 ]; then
 		echo Unable to verify the signature
@@ -100,5 +101,6 @@
 	fi
 
-	tar xvfj ${TARBALL}
+	echo "==== Decompressing QEMU sources ===="
+	tar xfj ${TARBALL}
 	cd ${SOURCEDIR}
 fi
@@ -106,12 +108,11 @@
 echo "==== Configuring QEMU ===="
 
-./configure --target-list=i386-softmmu,x86_64-softmmu,arm-softmmu,aarch64-softmmu,ppc-softmmu,sparc64-softmmu,mips-softmmu,mipsel-softmmu --audio-drv-list=pa
+./configure --target-list=i386-softmmu,x86_64-softmmu,arm-softmmu,aarch64-softmmu,ppc-softmmu,sparc64-softmmu,mips-softmmu,mipsel-softmmu --enable-gtk --enable-vte --enable-kvm --enable-curses --enable-opengl --enable-slirp --enable-pa --audio-drv-list=pa --prefix="$INSTALL_PREFIX" || exit 1
 
 echo "==== Building QEMU ===="
 
-make -j 4
+make -j`nproc` || exit 1
 
 echo "==== Installing QEMU ===="
 
-sudo make install
-
+make install
Index: kernel/arch/abs32le/_link.ld.in
===================================================================
--- kernel/arch/abs32le/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/abs32le/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -3,26 +3,55 @@
 		kernel_load_address = .;
 		ktext_start = .;
-		*(.text);
+		*(.text .text.*);
 		ktext_end = .;
 	}
 	.data : {
 		kdata_start = .;
-		*(.data);                       /* initialized data */
-		*(.bss);                        /* uninitialized static variables */
+		*(.data .data.*);                       /* initialized data */
+		*(.bss .bss.*);                        /* uninitialized static variables */
 		*(COMMON);                      /* global variables */
 
-		*(.rodata*);
-		*(.sdata);
-		*(.reginfo);
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);
+		*(.rodata .rodata.*);
+		*(.eh_frame .eh_frame.*);       /* stack unwinding data */
+		*(.eh_frame_hdr .eh_frame_hdr.*);
+		*(.sdata .sdata.*);
 	}
 	.sbss : {
-		*(.sbss);
-		*(.scommon);
+		*(.sbss .sbss.*);
+		*(.scommon .scommon.*);
 	}
 
 	kdata_end = .;
+
+	.comment 0 : { *(.comment); }
+	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
+	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
+	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
+	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
+	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
+	.debug_pubnames 0 : { *(.debug_pubnames); }
+	.debug_pubtypes 0 : { *(.debug_pubtypes); }
+	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
+	.debug_str 0 : { *(.debug_str); }
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/abs32le/include/arch/asm.h
===================================================================
--- kernel/arch/abs32le/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/abs32le/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -67,4 +67,13 @@
 }
 
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+	/*
+	 * Some ISAs have a special instruction for the body of a busy wait loop,
+	 * such as in spinlock and the like. Using it allows the CPU to optimize
+	 * its operation. For an example, see the "pause" instruction on x86.
+	 */
+}
+
 _NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t val)
 {
@@ -188,4 +197,15 @@
 }
 
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep(void)
+{
+	interrupts_enable();
+	cpu_sleep();
+	interrupts_disable();
+}
+
 #endif
 
Index: kernel/arch/abs32le/include/arch/context.h
===================================================================
--- kernel/arch/abs32le/include/arch/context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/abs32le/include/arch/context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -49,5 +49,4 @@
 	uintptr_t sp;
 	uintptr_t pc;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/abs32le/include/arch/context_offset.h
===================================================================
--- kernel/arch/abs32le/include/arch/context_offset.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/abs32le/include/arch/context_offset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,5 +37,4 @@
 
 #define OFFSET_PC  0x00
-#define OFFSET_IPL 0x04
 
 #endif
Index: kernel/arch/abs32le/include/arch/fpu_context.h
===================================================================
--- kernel/arch/abs32le/include/arch/fpu_context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/abs32le/include/arch/fpu_context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,6 +36,4 @@
 #define KERN_abs32le_FPU_CONTEXT_H_
 
-#define FPU_CONTEXT_ALIGN  16
-
 /*
  * On real hardware this stores the FPU registers
Index: kernel/arch/amd64/_link.ld.in
===================================================================
--- kernel/arch/amd64/_link.ld.in	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/_link.ld.in	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -17,42 +17,75 @@
 	.unmapped (BOOT_OFFSET + SIZEOF_HEADERS): AT (BOOT_OFFSET + SIZEOF_HEADERS) {
 		unmapped_start = .;
-		*(K_TEXT_START);
-		*(K_DATA_START);
-		*(K_INI_PTLS);
+		KEEP(*(K_TEXT_START));
+		KEEP(*(K_DATA_START));
+		KEEP(*(K_INI_PTLS));
 		unmapped_end = .;
 	}
 
-	.mapped (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS + SIZEOF(.unmapped)) : AT (BOOT_OFFSET + SIZEOF_HEADERS + SIZEOF(.unmapped)) {
+	.text (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS + SIZEOF(.unmapped)) : AT (BOOT_OFFSET + SIZEOF_HEADERS + SIZEOF(.unmapped)) {
 		ktext_start = .;
 		*(.text .text.*);
 		ktext_end = .;
+	}
 
+	/* stack unwinding data */
+	.eh_frame_hdr : {
+		eh_frame_hdr_start = .;
+		*(.eh_frame_hdr) *(.eh_frame_entry .eh_frame_entry.*);
+		eh_frame_hdr_end = .;
+	}
+	.eh_frame : {
+		eh_frame_start = .;
+		KEEP(*(.eh_frame .eh_frame.*));
+		eh_frame_end = .;
+	}
+
+	.data : {
 		kdata_start = .;
-		*(.data);              /* initialized data */
-		*(.rodata .rodata.*);  /* string literals */
-		*(COMMON);      /* global variables */
+		*(.rodata .rodata.*);  /* read-only global variables */
+		*(.data .data.*);      /* non-zero initialized global variables */
 
-		/* bss can't be omitted from the ELF image. */
-		*(.bss);        /* uninitialized static variables */
+		/*
+		 * When .bss is not physically present in the ELF file (MemSz > FileSz)
+		 * the kernel crashes during early boot. Not sure which part of the
+		 * boot process is to blame, for now just keep .bss packaged with .data
+		 * so that FileSz == MemSz.
+		 */
 
-		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);    /* Symbol table, must be LAST symbol!*/
-
+		 *(.bss .bss.*);        /* uninitialized global variables */
+		*(COMMON);             /* non-`static` global variables without an extern declaration */
 		kdata_end = .;
 	}
 
-#ifdef CONFIG_LINE_DEBUG
 	.comment 0 : { *(.comment); }
 	.debug_abbrev 0 : { *(.debug_abbrev); }
+	.debug_abbrev.dwo 0 : { *(	.debug_abbrev.dwo); }
+	.debug_addr 0 : { *(.debug_addr); }
 	.debug_aranges 0 : { *(.debug_aranges); }
+	.debug_cu_index 0 : { *(.debug_cu_index); }
+	.debug_frame 0 : { *(.debug_frame); }
+	.debug_frame_hdr 0 : { *(.debug_frame_hdr); }
 	.debug_info 0 : { *(.debug_info); }
+	.debug_info.dwo 0 : { *(.debug_info.dwo); }
 	.debug_line 0 : { *(.debug_line); }
+	.debug_line.dwo 0 : { *(.debug_line.dwo); }
+	.debug_line_str 0 : { *(.debug_line_str); }
 	.debug_loc 0 : { *(.debug_loc); }
+	.debug_loclists 0 : { *(.debug_loclists); }
+	.debug_loclists.dwo 0 : { *(.debug_loclists.dwo); }
+	.debug_macinfo 0 : { *(.debug_macinfo); }
+	.debug_macro 0 : { *(.debug_macro); }
+	.debug_macro.dwo 0 : { *(.debug_macro.dwo); }
+	.debug_names 0 : { *(.debug_names); }
 	.debug_pubnames 0 : { *(.debug_pubnames); }
 	.debug_pubtypes 0 : { *(.debug_pubtypes); }
 	.debug_ranges 0 : { *(.debug_ranges); }
+	.debug_rnglists 0 : { *(.debug_rnglists); }
 	.debug_str 0 : { *(.debug_str); }
-#endif
+	.debug_str.dwo 0 : { *(.debug_str.dwo); }
+	.debug_str_offsets 0 : { *(.debug_str_offsets); }
+	.debug_str_offsets.dwo 0 : { *(.debug_str_offsets.dwo); }
+	.debug_tu_index 0 : { *(.debug_tu_index); }
+	.debug_types 0 : { *(.debug_types); }
 
 	/DISCARD/ : {
Index: kernel/arch/amd64/include/arch/asm.h
===================================================================
--- kernel/arch/amd64/include/arch/asm.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/include/arch/asm.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,8 +43,18 @@
 #define IO_SPACE_BOUNDARY	((void *) (64 * 1024))
 
-_NO_TRACE static inline void cpu_sleep(void)
-{
-	asm volatile (
+/** Enables interrupts and blocks until an interrupt arrives,
+ * atomically if possible on target architecture.
+ * Disables interrupts again before returning to caller.
+ */
+_NO_TRACE static inline void cpu_interruptible_sleep()
+{
+	/*
+	 * On x86, "sti" enables interrupts after the next instruction.
+	 * Therefore, this sequence is guaranteed to be atomic.
+	 */
+	asm volatile (
+	    "sti\n"
 	    "hlt\n"
+	    "cli\n"
 	);
 }
@@ -57,4 +67,11 @@
 		);
 	}
+}
+
+_NO_TRACE static inline void cpu_spin_hint(void)
+{
+	asm volatile (
+	    "pause\n"
+	);
 }
 
Index: kernel/arch/amd64/include/arch/context_struct.h
===================================================================
--- kernel/arch/amd64/include/arch/context_struct.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/include/arch/context_struct.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,6 +39,5 @@
 #define CONTEXT_OFFSET_R15  0x38
 #define CONTEXT_OFFSET_TP   0x40
-#define CONTEXT_OFFSET_IPL  0x48
-#define CONTEXT_SIZE        0x50
+#define CONTEXT_SIZE        0x48
 
 #ifndef __ASSEMBLER__
@@ -60,5 +59,4 @@
 	uint64_t r15;
 	uint64_t tp;
-	ipl_t ipl;
 } context_t;
 
Index: kernel/arch/amd64/include/arch/mm/page.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/page.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/amd64/include/arch/mm/page.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -93,16 +93,11 @@
 /* Get PTE address accessors for each level. */
 #define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
-	((pte_t *) ((((uint64_t) ((pte_t *) (ptl0))[(i)].addr_12_31) << 12) | \
-	    (((uint64_t) ((pte_t *) (ptl0))[(i)].addr_32_51) << 32)))
+	((pte_t *) (((uint64_t) ((pte_t *) (ptl0))[(i)].addr_12_51) << 12))
 #define GET_PTL2_ADDRESS_ARCH(ptl1, i) \
-	((pte_t *) ((((uint64_t) ((pte_t *) (ptl1))[(i)].addr_12_31) << 12) | \
-	    (((uint64_t) ((pte_t *) (ptl1))[(i)].addr_32_51) << 32)))
+	((pte_t *) (((uint64_t) ((pte_t *) (ptl1))[(i)].addr_12_51) << 12))
 #define GET_PTL3_ADDRESS_ARCH(ptl2, i) \
-	((pte_t *) ((((uint64_t) ((pte_t *) (ptl2))[(i)].addr_12_31) << 12) | \
-	    (((uint64_t) ((pte_t *) (ptl2))[(i)].addr_32_51) << 32)))
+	((pte_t *) (((uint64_t) ((pte_t *) (ptl2))[(i)].addr_12_51) << 12))
 #define GET_FRAME_ADDRESS_ARCH(ptl3, i) \
-	((uintptr_t *) \
-	    ((((uint64_t) ((pte_t *) (ptl3))[(i)].addr_12_31) << 12) | \
-	    (((uint64_t) ((pte_t *) (ptl3))[(i)].addr_32_51) << 32)))
+	((uintptr_t *) (((uint64_t) ((pte_t *) (ptl3))[(i)].addr_12_51) << 12))
 
 /* Set PTE address accessors for each level. */
@@ -154,6 +149,5 @@
 	((p)->present != 0)
 #define PTE_GET_FRAME_ARCH(p) \
-	((((uintptr_t) (p)->addr_12_31) << 12) | \
-	    ((uintptr_t) (p)->addr_32_51 << 32))
+	(((uintptr_t) (p)->addr_12_51) << 12)
 #define PTE_WRITABLE_ARCH(p) \
 	((p)->writeable != 0)
@@ -198,10 +192,10 @@
 	unsigned int accessed : 1;
 	unsigned int dirty : 1;
-	unsigned int unused : 1;
+	unsigned int pat : 1;
 	unsigned int global : 1;
 	unsigned int soft_valid : 1;  /**< Valid content even if present bit is cleared. */
 	unsigned int avl : 2;
-	unsigned int addr_12_31 : 30;
-	unsigned int addr_32_51 : 21;
+	unsigned long addr_12_51 : 40;
+	unsigned int reserved : 11;
 	unsigned int no_execute : 1;
 } __attribute__((packed)) pte_t;
@@ -217,5 +211,6 @@
 	    p->writeable << PAGE_WRITE_SHIFT |
 	    (!p->no_execute) << PAGE_EXEC_SHIFT |
-	    p->global << PAGE_GLOBAL_SHIFT);
+	    p->global << PAGE_GLOBAL_SHIFT |
+	    p->page_write_through << PAGE_WRITE_COMBINE_SHIFT);
 }
 
@@ -224,6 +219,5 @@
 	pte_t *p = &pt[i];
 
-	p->addr_12_31 = (a >> 12) & UINT32_C(0xfffff);
-	p->addr_32_51 = a >> 32;
+	p->addr_12_51 = (a >> 12) & UINT64_C(0xffffffffff);
 }
 
@@ -232,5 +226,4 @@
 	pte_t *p = &pt[i];
 
-	p->page_cache_disable = !(flags & PAGE_CACHEABLE);
 	p->present = !(flags & PAGE_NOT_PRESENT);
 	p->uaccessible = (flags & PAGE_USER) != 0;
@@ -239,4 +232,14 @@
 	p->global = (flags & PAGE_GLOBAL) != 0;
 
+	if (flags & PAGE_WRITE_COMBINE) {
+		/* We have mapped PCD+PWT bits to write-combine mode via PAT MSR. */
+		/* (If PAT is unsupported, it will default to uncached.) */
+		p->page_cache_disable = 1;
+		p->page_write_through = 1;
+	} else {
+		p->page_cache_disable = !(flags & PAGE_CACHEABLE);
+		p->page_write_through = 0;
+	}
+
 	/*
 	 * Ensure that there is at least one bit set even if the present bit is cleared.
